package nianioTest;

import nianio.AppCommand;
import nianio.AppState;
import nianio.ExternalCommand;
import nianio.ExternalCommands;
import nianioTest.nianio.NianioFactory;

public class AppInvoker {
	private final ExternalCommand.MM deliverer;
	private AppState state;

	private AppInvoker(ExternalCommand.MM deliverer) {
		this.deliverer = deliverer;
		this.state = NianioFactory.createAppState();
	}

	public static AppInvoker create(ExternalCommand.MM deliverer) {
		return new AppInvoker(deliverer);
	}

	public void invoke(AppCommand cmd) {
		ExternalCmdsAcc acc = new ExternalCmdsAcc();
		state = NianioFactory.createAppNianio().invoke(state, cmd, acc);
		sendExternalCmds(acc.getResult());
	}

	private void sendExternalCmds(ExternalCommands cmds) {
		for (int i = 0; i < cmds.size(); i++) {
			deliverer.invoke(cmds.get(i));
		}
	}

	private class ExternalCmdsAcc implements ExternalCommand.MM {
		private ExternalCommands cmds = ExternalCommands.EMPTY;

		public ExternalCommands getResult() {
			return cmds;
		}

		public void invoke(ExternalCommand cmd) {
			cmds = cmds.add(cmd);
		}
	}
}
