package nianioTest.complib.repository;

import genrap.ui.framework.CompHandle;
import genrap.ui.framework.ParentComp;

import java.util.HashMap;
import java.util.Map;

import nianio.complib.DialogIdEvent;
import nianio.complib.DialogState;
import nianio.complib.UserDialogEvent;
import nianio.ids.UserDialogId;
import nianioTest.complib.windows.Dialog;

public class DialogRepository {
	private final CompsMap compsMap = new CompsMap();
	private final DialogIdEvent.MMIntf deliverer;

	public DialogRepository(DialogIdEvent.MM deliverer) {
		this.deliverer = DialogIdEvent.MMConv.asIntf(deliverer);
	}

	private static class CompsMap {
		private Map compsMap;

		public CompsMap() {
			this.compsMap = new HashMap();
		}

		public void put(UserDialogId id, Dialog comp) {
			this.compsMap.put(id, comp);
		}

		public Dialog get(UserDialogId id) {
			return (Dialog) this.compsMap.get(id);
		}
	}

	private class MyDeliverer implements UserDialogEvent.MM {
		final private UserDialogId id;

		public MyDeliverer(UserDialogId id) {
			this.id = id;
		}

		public void invoke(UserDialogEvent cmd) {
			deliverer.userDialog(id, cmd);
		}
	}

	public void addDialog(DialogState state, CompHandle content,
			ParentComp parent) {
		UserDialogId id = state.getId();
		Dialog dialog = Dialog.create(state.getTitle(), state.getIsModal(),
				state.getIsResizable(), content, parent,
				UserDialogEvent.MMConv.asIntf(new MyDeliverer(id)));
		compsMap.put(id, dialog);
	}

	public ParentComp getParentComp(UserDialogId id) {
		return compsMap.get(id).getParentComp();
	}

	public Dialog getDialog(UserDialogId id) {
		return compsMap.get(id);
	}

}
