package nianioTest.complib.repository;

import genrap.ui.framework.CompHandle;
import genrap.ui.framework.ParentComp;

import java.util.HashMap;
import java.util.Map;

import nianio.complib.CompLibIdEvent;
import nianio.complib.FrameEvent;
import nianio.complib.FrameState;
import nianio.ids.FrameId;
import nianioTest.complib.windows.Frame;

public class FrameRepository {
	private final CompsMap compsMap = new CompsMap();
	private final CompLibIdEvent.MMIntf deliverer;

	public FrameRepository(CompLibIdEvent.MMIntf deliverer) {
		this.deliverer = deliverer;
	}

	private static class CompsMap {
		private Map compsMap;

		public CompsMap() {
			this.compsMap = new HashMap();
		}

		public void put(FrameId id, Frame comp) {
			this.compsMap.put(id, comp);
		}

		public Frame get(FrameId id) {
			return (Frame) this.compsMap.get(id);
		}
	}

	private class MyDeliverer implements FrameEvent.MM {
		final private FrameId id;

		public MyDeliverer(FrameId id) {
			this.id = id;
		}

		public void invoke(FrameEvent cmd) {
			deliverer.frame(id, cmd);
		}
	}

	public void addFrame(FrameState state, CompHandle content) {
		FrameId id = state.getId();
		Frame frame = Frame.create(state.getTitle(), content,
				FrameEvent.MMConv.asIntf(new MyDeliverer(id)));
		compsMap.put(id, frame);
	}

	public ParentComp getParentComp(FrameId id) {
		return compsMap.get(id).getParentComp();
	}

	public Frame get(FrameId id) {
		return compsMap.get(id);
	}
}
