package nianioTest.complib.windows;

import genrap.ui.compLib.base.CloseHandler;
import genrap.ui.compLib.base.DialogHandle;
import genrap.ui.framework.CompHandle;
import genrap.ui.framework.ParentComp;
import nianio.complib.CreatedDialogCommand;
import nianio.complib.UserDialogEvent;
import ocean.common.Err;
import ocean.models.Model;
import ocean.models.SimpleModel;

public class Dialog {
	private final UserDialogEvent.MMIntf invoker;
	private final DialogHandle handle;
	private final ParentComp parentComp;

	private Dialog(String title, boolean isModal, boolean isResizable,
			CompHandle content, ParentComp parentComp,
			UserDialogEvent.MMIntf invoker) {
		this.invoker = invoker;
		this.parentComp = parentComp;
		Model/*String*/titleM = new SimpleModel(title).getModel();
		handle = genrap.ui.compLib.j2se.comps.Dialog.create(titleM, isResizable);
		handle.setCloseHandler(new DialogCloseHandler());
		handle.setComp(content.getComp());
	}

	public static Dialog create(String title, boolean isModal,
			boolean isResizable, CompHandle content, ParentComp parentComp,
			UserDialogEvent.MMIntf invoker) {
		return new Dialog(title, isModal, isResizable, content, parentComp,
				invoker);
	}

	private class DialogCloseHandler implements CloseHandler {
		public boolean close() {
			invoker.closing();
			return false;
		}
	}

	public void post(CreatedDialogCommand cmd) {
		if (cmd.isShow()) {
			handle.showModal(parentComp, true);
		} else if (cmd.isClose()) {
			handle.close();
		} else
			throw Err.errM(cmd);
	}

	public ParentComp getParentComp() {
		return null;
	}

}
