package nianioTest.nianio.cmdsfact;

import nianio.ExternalCommand;
import nianio.complib.CompLibCommand;
import nianio.complib.DialogCommand;
import nianio.complib.FrameCommand;
import nianio.complib.controls.ControlCommand;
import nianio.complib.controls.LabelCommand;
import nianio.complib.controls.RadioButtonGroupCommand;
import nianio.complib.controls.RadioButtonGroupIdCommand;
import nianio.complib.controls.TextBoxCommand;
import nianio.complib.filechooser.FileChooserCommand;
import nianio.complib.messagedialog.MessageDialogCommand;
import nianio.ids.LabelId;
import nianio.ids.RadioButtonGroupId;
import nianio.ids.TextBoxId;

public class ExternalCommandHelper {
	public static ExternalCommand createFileChooserCmd(
			FileChooserCommand fileChooserCmd) {
		return createDialogCmd(DialogCommand.createFileChooser(fileChooserCmd));
	}

	public static ExternalCommand createDialogCmd(DialogCommand dialogCmd) {
		return ExternalCommand.createComplib(CompLibCommand.createDialog(dialogCmd));
	}

	public static ExternalCommand createTextBoxCmd(TextBoxCommand textBoxCmd,
			TextBoxId textBoxId) {
		return ExternalCommand.createComplib(CompLibCommand.createControl(ControlCommand.mkTextBox(
				textBoxId, textBoxCmd)));
	}

	public static ExternalCommand createFrameCmd(FrameCommand frameCmd) {
		return ExternalCommand.createComplib(CompLibCommand.createFrame(frameCmd));
	}

	public static ExternalCommand createLabelCmd(LabelId id, LabelCommand cmd) {
		return createCompLibCmd(ControlCommand.mkLabel(id, cmd));
	}

	public static ExternalCommand createRadioButtonGroupCmd(
			RadioButtonGroupId id, RadioButtonGroupCommand command) {
		return createCompLibCmd(ControlCommand.createRadioButtonGroup(RadioButtonGroupIdCommand.create(
				id, command)));
	}

	public static ExternalCommand createCompLibCmd(ControlCommand cmd) {
		return ExternalCommand.createComplib(CompLibCommand.createControl(cmd));
	}

	public static ExternalCommand createMessageDialogCmd(
			MessageDialogCommand messageDialogCmd) {
		return createDialogCmd(DialogCommand.createMessageDialog(messageDialogCmd));
	}

}
