package nianioTest.nianio.helper;

import nianio.Status;
import nianio.genrap.ReportGenerationFailure;
import nianio.genrap.ReportParams;
import ocean.common.Err;

public class MessageHelper {

	public static String getStatusString(Status status) {
		if (status.isGeneratingReport()) {
			int num = status.asGeneratingReport();
			if (num == 1)
				return "Genereating report...";
			return "Generating " + num + " reports...";
		} else if (status.isReady()) {
			return "Ready";
		} else
			throw Err.errM(status);
	}

	public static String getSuccessMsg(ReportParams params) {
		return "File " + params.getOutputFileName() + " saved";
	}

	public static String getFailureMsg(ReportGenerationFailure failure) {
		return "File " + failure.getParams().getOutputFileName()
				+ " not generated.\n" + failure.getCause();
	}

}
