package nianioTest.nianio.impl;

import nianio.SelectFileCmd;
import nianio.SelectFileState;
import nianio.SelectFileExtCmd.MMIntf;
import nianio.complib.filechooser.Extensions;
import nianio.complib.filechooser.FileChooserKind;
import nianioTest.nianio.types.SelectFileCmdInvokerIntf;
import nianioTest.nianio.types.SelectFileNianio;
import nianioTest.nianio.types.SelectFileNianioIntf;

public class SelectFileNianioImpl implements SelectFileNianioIntf {
	private final SelectFileCmdInvokerIntf invoker;

	private SelectFileNianioImpl(FileChooserKind kind, Extensions ext,
			String description) {
		this.invoker = new SelectFileCmdInvokerImpl(kind, ext, description);
	}

	public static SelectFileNianioIntf create(FileChooserKind kind,
			Extensions ext, String description) {
		return new SelectFileNianioImpl(kind, ext, description);
	}

	public SelectFileState invoke(SelectFileState state, SelectFileCmd cmd,
			MMIntf deliverer) {
		SelectFileState newState = SelectFileNianio.create(invoker).invoke(
				state, cmd, deliverer);
		updateState(state, newState, deliverer);
		return newState;
	}

	private static void updateState(SelectFileState state,
			SelectFileState newState, MMIntf deliverer) {
		if (!state.getFileName().equals(newState.getFileName()))
			deliverer.setFileName(newState.getFileName());
	}
}
