package nianio;

import schema.runtime.datatypes.ImmObject;
import nianio.genrap.GenrapPluginEvent;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class AppLogicCmd = variant {
 *	    run 
 *	 |  close 
 *	 |  setPdfOutput 
 *	 |  setHtmlOutput 
 *	 |  setXlsOutput 
 *	 |  generateRequest 
 *	 |  reportGenerated of GenrapPluginEvent  
 *	 |  reportFileCmd of SelectFileCmd  
 *	 |  xmlFileCmd of SelectFileCmd  
 *	 |  xsdFileCmd of SelectFileCmd  
 *	 |  outputFileCmd of SelectFileCmd  
 *	 |  messageDialogClosed of String  
 * }</pre>
 */ 
public class AppLogicCmd implements ImmObject {
	private static final int TYPE_HASH = 143215133;
	private int hash = 0;

	private static final AppLogicCmd CONST_RUN = new AppLogicCmd(0);
	private static final AppLogicCmd CONST_CLOSE = new AppLogicCmd(1);
	private static final AppLogicCmd CONST_SETPDFOUTPUT = new AppLogicCmd(2);
	private static final AppLogicCmd CONST_SETHTMLOUTPUT = new AppLogicCmd(3);
	private static final AppLogicCmd CONST_SETXLSOUTPUT = new AppLogicCmd(4);
	private static final AppLogicCmd CONST_GENERATEREQUEST = new AppLogicCmd(5);
	private final int variant;
	private final Object value;  

	private AppLogicCmd(int variant) {
		this.variant = variant;
		this.value = null;
	}

	private AppLogicCmd(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static AppLogicCmd createRun() {
		return CONST_RUN;
	}

	public static AppLogicCmd createClose() {
		return CONST_CLOSE;
	}

	public static AppLogicCmd createSetPdfOutput() {
		return CONST_SETPDFOUTPUT;
	}

	public static AppLogicCmd createSetHtmlOutput() {
		return CONST_SETHTMLOUTPUT;
	}

	public static AppLogicCmd createSetXlsOutput() {
		return CONST_SETXLSOUTPUT;
	}

	public static AppLogicCmd createGenerateRequest() {
		return CONST_GENERATEREQUEST;
	}

	public static AppLogicCmd createReportGenerated(GenrapPluginEvent value) {
		return new AppLogicCmd(6, value);
	}

	public static AppLogicCmd createReportFileCmd(SelectFileCmd value) {
		return new AppLogicCmd(7, value);
	}

	public static AppLogicCmd createXmlFileCmd(SelectFileCmd value) {
		return new AppLogicCmd(8, value);
	}

	public static AppLogicCmd createXsdFileCmd(SelectFileCmd value) {
		return new AppLogicCmd(9, value);
	}

	public static AppLogicCmd createOutputFileCmd(SelectFileCmd value) {
		return new AppLogicCmd(10, value);
	}

	public static AppLogicCmd createMessageDialogClosed(String value) {
		return new AppLogicCmd(11, value);
	}



	/** @return true, when this is run */
	public boolean isRun() {
		return variant == 0;
	}


	/** @return true, when this is close */
	public boolean isClose() {
		return variant == 1;
	}


	/** @return true, when this is setPdfOutput */
	public boolean isSetPdfOutput() {
		return variant == 2;
	}


	/** @return true, when this is setHtmlOutput */
	public boolean isSetHtmlOutput() {
		return variant == 3;
	}


	/** @return true, when this is setXlsOutput */
	public boolean isSetXlsOutput() {
		return variant == 4;
	}


	/** @return true, when this is generateRequest */
	public boolean isGenerateRequest() {
		return variant == 5;
	}


	/** @return true, when this is reportGenerated */
	public boolean isReportGenerated() {
		return variant == 6;
	}

	/** @return variant value, when this is reportGenerated; throws Exception otherwise */
	public GenrapPluginEvent asReportGenerated() {
		SchemaException.ensure(isReportGenerated());
		return (GenrapPluginEvent)value;
	}

	/** @return true, when this is reportFileCmd */
	public boolean isReportFileCmd() {
		return variant == 7;
	}

	/** @return variant value, when this is reportFileCmd; throws Exception otherwise */
	public SelectFileCmd asReportFileCmd() {
		SchemaException.ensure(isReportFileCmd());
		return (SelectFileCmd)value;
	}

	/** @return true, when this is xmlFileCmd */
	public boolean isXmlFileCmd() {
		return variant == 8;
	}

	/** @return variant value, when this is xmlFileCmd; throws Exception otherwise */
	public SelectFileCmd asXmlFileCmd() {
		SchemaException.ensure(isXmlFileCmd());
		return (SelectFileCmd)value;
	}

	/** @return true, when this is xsdFileCmd */
	public boolean isXsdFileCmd() {
		return variant == 9;
	}

	/** @return variant value, when this is xsdFileCmd; throws Exception otherwise */
	public SelectFileCmd asXsdFileCmd() {
		SchemaException.ensure(isXsdFileCmd());
		return (SelectFileCmd)value;
	}

	/** @return true, when this is outputFileCmd */
	public boolean isOutputFileCmd() {
		return variant == 10;
	}

	/** @return variant value, when this is outputFileCmd; throws Exception otherwise */
	public SelectFileCmd asOutputFileCmd() {
		SchemaException.ensure(isOutputFileCmd());
		return (SelectFileCmd)value;
	}

	/** @return true, when this is messageDialogClosed */
	public boolean isMessageDialogClosed() {
		return variant == 11;
	}

	/** @return variant value, when this is messageDialogClosed; throws Exception otherwise */
	public String asMessageDialogClosed() {
		SchemaException.ensure(isMessageDialogClosed());
		return ((String)value);
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isRun()) {
			;
		} else if (isClose()) {
			;
		} else if (isSetPdfOutput()) {
			;
		} else if (isSetHtmlOutput()) {
			;
		} else if (isSetXlsOutput()) {
			;
		} else if (isGenerateRequest()) {
			;
		} else if (isReportGenerated()) {
			;
		} else if (isReportFileCmd()) {
			;
		} else if (isXmlFileCmd()) {
			;
		} else if (isXsdFileCmd()) {
			;
		} else if (isOutputFileCmd()) {
			;
		} else if (isMessageDialogClosed()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isRun()) {
			;
		} else if (isClose()) {
			;
		} else if (isSetPdfOutput()) {
			;
		} else if (isSetHtmlOutput()) {
			;
		} else if (isSetXlsOutput()) {
			;
		} else if (isGenerateRequest()) {
			;
		} else if (isReportGenerated()) {
			asReportGenerated();
		} else if (isReportFileCmd()) {
			asReportFileCmd();
		} else if (isXmlFileCmd()) {
			asXmlFileCmd();
		} else if (isXsdFileCmd()) {
			asXsdFileCmd();
		} else if (isOutputFileCmd()) {
			asOutputFileCmd();
		} else if (isMessageDialogClosed()) {
			asMessageDialogClosed();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isRun())
			return "run";		
		if (isClose())
			return "close";		
		if (isSetPdfOutput())
			return "setPdfOutput";		
		if (isSetHtmlOutput())
			return "setHtmlOutput";		
		if (isSetXlsOutput())
			return "setXlsOutput";		
		if (isGenerateRequest())
			return "generateRequest";		
		if (isReportGenerated())
			return "reportGenerated" + "(" + asReportGenerated() + ")";
		if (isReportFileCmd())
			return "reportFileCmd" + "(" + asReportFileCmd() + ")";
		if (isXmlFileCmd())
			return "xmlFileCmd" + "(" + asXmlFileCmd() + ")";
		if (isXsdFileCmd())
			return "xsdFileCmd" + "(" + asXsdFileCmd() + ")";
		if (isOutputFileCmd())
			return "outputFileCmd" + "(" + asOutputFileCmd() + ")";
		if (isMessageDialogClosed())
			return "messageDialogClosed" + "(" + asMessageDialogClosed() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(AppLogicCmd obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof AppLogicCmd) 
			&& this.eq((AppLogicCmd)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for AppLogicCmd
	 */
	public static interface MM {
		public void invoke(AppLogicCmd cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for AppLogicCmd
	 */
	public static interface MMIntf {
		public void run();
		public void close();
		public void setPdfOutput();
		public void setHtmlOutput();
		public void setXlsOutput();
		public void generateRequest();
		public void reportGenerated(GenrapPluginEvent value);
		public void reportFileCmd(SelectFileCmd value);
		public void xmlFileCmd(SelectFileCmd value);
		public void xsdFileCmd(SelectFileCmd value);
		public void outputFileCmd(SelectFileCmd value);
		public void messageDialogClosed(String value);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for AppLogicCmd
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(AppLogicCmd cmd) {
				 if (cmd.isRun()) {
					mm.run();
				} else if (cmd.isClose()) {
					mm.close();
				} else if (cmd.isSetPdfOutput()) {
					mm.setPdfOutput();
				} else if (cmd.isSetHtmlOutput()) {
					mm.setHtmlOutput();
				} else if (cmd.isSetXlsOutput()) {
					mm.setXlsOutput();
				} else if (cmd.isGenerateRequest()) {
					mm.generateRequest();
				} else if (cmd.isReportGenerated()) {
					mm.reportGenerated(cmd.asReportGenerated());
				} else if (cmd.isReportFileCmd()) {
					mm.reportFileCmd(cmd.asReportFileCmd());
				} else if (cmd.isXmlFileCmd()) {
					mm.xmlFileCmd(cmd.asXmlFileCmd());
				} else if (cmd.isXsdFileCmd()) {
					mm.xsdFileCmd(cmd.asXsdFileCmd());
				} else if (cmd.isOutputFileCmd()) {
					mm.outputFileCmd(cmd.asOutputFileCmd());
				} else if (cmd.isMessageDialogClosed()) {
					mm.messageDialogClosed(cmd.asMessageDialogClosed());
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void run() {
				mm.invoke(AppLogicCmd.createRun());
			}
		
			public void close() {
				mm.invoke(AppLogicCmd.createClose());
			}
		
			public void setPdfOutput() {
				mm.invoke(AppLogicCmd.createSetPdfOutput());
			}
		
			public void setHtmlOutput() {
				mm.invoke(AppLogicCmd.createSetHtmlOutput());
			}
		
			public void setXlsOutput() {
				mm.invoke(AppLogicCmd.createSetXlsOutput());
			}
		
			public void generateRequest() {
				mm.invoke(AppLogicCmd.createGenerateRequest());
			}
		
			public void reportGenerated(GenrapPluginEvent value) {
				mm.invoke(AppLogicCmd.createReportGenerated(value));
			}
		
			public void reportFileCmd(SelectFileCmd value) {
				mm.invoke(AppLogicCmd.createReportFileCmd(value));
			}
		
			public void xmlFileCmd(SelectFileCmd value) {
				mm.invoke(AppLogicCmd.createXmlFileCmd(value));
			}
		
			public void xsdFileCmd(SelectFileCmd value) {
				mm.invoke(AppLogicCmd.createXsdFileCmd(value));
			}
		
			public void outputFileCmd(SelectFileCmd value) {
				mm.invoke(AppLogicCmd.createOutputFileCmd(value));
			}
		
			public void messageDialogClosed(String value) {
				mm.invoke(AppLogicCmd.createMessageDialogClosed(value));
			}
		
		}
	}
}