package nianio;

import schema.runtime.datatypes.ImmObject;
import nianio.genrap.ReportParams;
import schema.runtime.err.SchemaException;
import nianio.genrap.OutputKind;
import ocean.common.Err;
import nianio.complib.messagedialog.MessageDialogParams;


/** 
 * <pre>Autogenerated class AppLogicExtCmd = variant {
 *	    generate of ReportParams  
 *	 |  showMainFrame of MainFrame  
 *	 |  setOutput of OutputKind  
 *	 |  setStatus of String  
 *	 |  reportFile of SelectFileExtCmd  
 *	 |  xmlFile of SelectFileExtCmd  
 *	 |  xsdFile of SelectFileExtCmd  
 *	 |  outputFile of SelectFileExtCmd  
 *	 |  showMessage of ShowMessageCmd  
 *	 |  closeMainFrame 
 *	 |  exit 
 * }</pre>
 */ 
public class AppLogicExtCmd implements ImmObject {
	private static final int TYPE_HASH = 1687463830;
	private int hash = 0;

	private static final AppLogicExtCmd CONST_CLOSEMAINFRAME = new AppLogicExtCmd(9);
	private static final AppLogicExtCmd CONST_EXIT = new AppLogicExtCmd(10);
	private final int variant;
	private final Object value;  

	private AppLogicExtCmd(int variant) {
		this.variant = variant;
		this.value = null;
	}

	private AppLogicExtCmd(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static AppLogicExtCmd createGenerate(ReportParams value) {
		return new AppLogicExtCmd(0, value);
	}

	public static AppLogicExtCmd createShowMainFrame(MainFrame value) {
		return new AppLogicExtCmd(1, value);
	}

	public static AppLogicExtCmd createSetOutput(OutputKind value) {
		return new AppLogicExtCmd(2, value);
	}

	public static AppLogicExtCmd createSetStatus(String value) {
		return new AppLogicExtCmd(3, value);
	}

	public static AppLogicExtCmd createReportFile(SelectFileExtCmd value) {
		return new AppLogicExtCmd(4, value);
	}

	public static AppLogicExtCmd createXmlFile(SelectFileExtCmd value) {
		return new AppLogicExtCmd(5, value);
	}

	public static AppLogicExtCmd createXsdFile(SelectFileExtCmd value) {
		return new AppLogicExtCmd(6, value);
	}

	public static AppLogicExtCmd createOutputFile(SelectFileExtCmd value) {
		return new AppLogicExtCmd(7, value);
	}

	public static AppLogicExtCmd createShowMessage(ShowMessageCmd value) {
		return new AppLogicExtCmd(8, value);
	}

	public static AppLogicExtCmd createCloseMainFrame() {
		return CONST_CLOSEMAINFRAME;
	}

	public static AppLogicExtCmd createExit() {
		return CONST_EXIT;
	}


	public static AppLogicExtCmd mkShowMainFrame(
			String reportFileName
			, String xmlFileName
			, String xsdFileName
			, String outputFileName
			, OutputKind outputKind
			, String status
	) {
		return createShowMainFrame( MainFrame.create(
							reportFileName
							, xmlFileName
							, xsdFileName
							, outputFileName
							, outputKind
							, status
							 ));
	}
	
	public static AppLogicExtCmd mkShowMessage(
			String key
			, MessageDialogParams params
	) {
		return createShowMessage( ShowMessageCmd.create(
							key
							, params
							 ));
	}
	

	/** @return true, when this is generate */
	public boolean isGenerate() {
		return variant == 0;
	}

	/** @return variant value, when this is generate; throws Exception otherwise */
	public ReportParams asGenerate() {
		SchemaException.ensure(isGenerate());
		return (ReportParams)value;
	}

	/** @return true, when this is showMainFrame */
	public boolean isShowMainFrame() {
		return variant == 1;
	}

	/** @return variant value, when this is showMainFrame; throws Exception otherwise */
	public MainFrame asShowMainFrame() {
		SchemaException.ensure(isShowMainFrame());
		return (MainFrame)value;
	}

	/** @return true, when this is setOutput */
	public boolean isSetOutput() {
		return variant == 2;
	}

	/** @return variant value, when this is setOutput; throws Exception otherwise */
	public OutputKind asSetOutput() {
		SchemaException.ensure(isSetOutput());
		return (OutputKind)value;
	}

	/** @return true, when this is setStatus */
	public boolean isSetStatus() {
		return variant == 3;
	}

	/** @return variant value, when this is setStatus; throws Exception otherwise */
	public String asSetStatus() {
		SchemaException.ensure(isSetStatus());
		return ((String)value);
	}

	/** @return true, when this is reportFile */
	public boolean isReportFile() {
		return variant == 4;
	}

	/** @return variant value, when this is reportFile; throws Exception otherwise */
	public SelectFileExtCmd asReportFile() {
		SchemaException.ensure(isReportFile());
		return (SelectFileExtCmd)value;
	}

	/** @return true, when this is xmlFile */
	public boolean isXmlFile() {
		return variant == 5;
	}

	/** @return variant value, when this is xmlFile; throws Exception otherwise */
	public SelectFileExtCmd asXmlFile() {
		SchemaException.ensure(isXmlFile());
		return (SelectFileExtCmd)value;
	}

	/** @return true, when this is xsdFile */
	public boolean isXsdFile() {
		return variant == 6;
	}

	/** @return variant value, when this is xsdFile; throws Exception otherwise */
	public SelectFileExtCmd asXsdFile() {
		SchemaException.ensure(isXsdFile());
		return (SelectFileExtCmd)value;
	}

	/** @return true, when this is outputFile */
	public boolean isOutputFile() {
		return variant == 7;
	}

	/** @return variant value, when this is outputFile; throws Exception otherwise */
	public SelectFileExtCmd asOutputFile() {
		SchemaException.ensure(isOutputFile());
		return (SelectFileExtCmd)value;
	}

	/** @return true, when this is showMessage */
	public boolean isShowMessage() {
		return variant == 8;
	}

	/** @return variant value, when this is showMessage; throws Exception otherwise */
	public ShowMessageCmd asShowMessage() {
		SchemaException.ensure(isShowMessage());
		return (ShowMessageCmd)value;
	}

	/** @return true, when this is closeMainFrame */
	public boolean isCloseMainFrame() {
		return variant == 9;
	}


	/** @return true, when this is exit */
	public boolean isExit() {
		return variant == 10;
	}




	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isGenerate()) {
			;
		} else if (isShowMainFrame()) {
			;
		} else if (isSetOutput()) {
			;
		} else if (isSetStatus()) {
			;
		} else if (isReportFile()) {
			;
		} else if (isXmlFile()) {
			;
		} else if (isXsdFile()) {
			;
		} else if (isOutputFile()) {
			;
		} else if (isShowMessage()) {
			;
		} else if (isCloseMainFrame()) {
			;
		} else if (isExit()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isGenerate()) {
			asGenerate();
		} else if (isShowMainFrame()) {
			asShowMainFrame();
		} else if (isSetOutput()) {
			asSetOutput();
		} else if (isSetStatus()) {
			asSetStatus();
		} else if (isReportFile()) {
			asReportFile();
		} else if (isXmlFile()) {
			asXmlFile();
		} else if (isXsdFile()) {
			asXsdFile();
		} else if (isOutputFile()) {
			asOutputFile();
		} else if (isShowMessage()) {
			asShowMessage();
		} else if (isCloseMainFrame()) {
			;
		} else if (isExit()) {
			;
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isGenerate())
			return "generate" + "(" + asGenerate() + ")";
		if (isShowMainFrame())
			return "showMainFrame" + "(" + asShowMainFrame() + ")";
		if (isSetOutput())
			return "setOutput" + "(" + asSetOutput() + ")";
		if (isSetStatus())
			return "setStatus" + "(" + asSetStatus() + ")";
		if (isReportFile())
			return "reportFile" + "(" + asReportFile() + ")";
		if (isXmlFile())
			return "xmlFile" + "(" + asXmlFile() + ")";
		if (isXsdFile())
			return "xsdFile" + "(" + asXsdFile() + ")";
		if (isOutputFile())
			return "outputFile" + "(" + asOutputFile() + ")";
		if (isShowMessage())
			return "showMessage" + "(" + asShowMessage() + ")";
		if (isCloseMainFrame())
			return "closeMainFrame";		
		if (isExit())
			return "exit";		
		throw SchemaException.err();
	}
	
	public boolean eq(AppLogicExtCmd obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof AppLogicExtCmd) 
			&& this.eq((AppLogicExtCmd)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for AppLogicExtCmd
	 */
	public static interface MM {
		public void invoke(AppLogicExtCmd cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for AppLogicExtCmd
	 */
	public static interface MMIntf {
		public void generate(ReportParams value);
		public void showMainFrame(
				 String reportFileName
				, String xmlFileName
				, String xsdFileName
				, String outputFileName
				, OutputKind outputKind
				, String status
		);
		public void setOutput(OutputKind value);
		public void setStatus(String value);
		public void reportFile(SelectFileExtCmd value);
		public void xmlFile(SelectFileExtCmd value);
		public void xsdFile(SelectFileExtCmd value);
		public void outputFile(SelectFileExtCmd value);
		public void showMessage(
				 String key
				, MessageDialogParams params
		);
		public void closeMainFrame();
		public void exit();
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for AppLogicExtCmd
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(AppLogicExtCmd cmd) {
				 if (cmd.isGenerate()) {
					mm.generate(cmd.asGenerate());
				} else if (cmd.isShowMainFrame()) {
					MainFrame val = cmd.asShowMainFrame();
					mm.showMainFrame(
							 val.getReportFileName()
							, val.getXmlFileName()
							, val.getXsdFileName()
							, val.getOutputFileName()
							, val.getOutputKind()
							, val.getStatus()
					);
				} else if (cmd.isSetOutput()) {
					mm.setOutput(cmd.asSetOutput());
				} else if (cmd.isSetStatus()) {
					mm.setStatus(cmd.asSetStatus());
				} else if (cmd.isReportFile()) {
					mm.reportFile(cmd.asReportFile());
				} else if (cmd.isXmlFile()) {
					mm.xmlFile(cmd.asXmlFile());
				} else if (cmd.isXsdFile()) {
					mm.xsdFile(cmd.asXsdFile());
				} else if (cmd.isOutputFile()) {
					mm.outputFile(cmd.asOutputFile());
				} else if (cmd.isShowMessage()) {
					ShowMessageCmd val = cmd.asShowMessage();
					mm.showMessage(
							 val.getKey()
							, val.getParams()
					);
				} else if (cmd.isCloseMainFrame()) {
					mm.closeMainFrame();
				} else if (cmd.isExit()) {
					mm.exit();
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void generate(ReportParams value) {
				mm.invoke(AppLogicExtCmd.createGenerate(value));
			}
		
			public void showMainFrame(
							 String reportFileName
							, String xmlFileName
							, String xsdFileName
							, String outputFileName
							, OutputKind outputKind
							, String status
			) {
				mm.invoke( AppLogicExtCmd.createShowMainFrame(
								MainFrame.create( 
									reportFileName, xmlFileName, xsdFileName, outputFileName, outputKind, status)));		
			}
		
			public void setOutput(OutputKind value) {
				mm.invoke(AppLogicExtCmd.createSetOutput(value));
			}
		
			public void setStatus(String value) {
				mm.invoke(AppLogicExtCmd.createSetStatus(value));
			}
		
			public void reportFile(SelectFileExtCmd value) {
				mm.invoke(AppLogicExtCmd.createReportFile(value));
			}
		
			public void xmlFile(SelectFileExtCmd value) {
				mm.invoke(AppLogicExtCmd.createXmlFile(value));
			}
		
			public void xsdFile(SelectFileExtCmd value) {
				mm.invoke(AppLogicExtCmd.createXsdFile(value));
			}
		
			public void outputFile(SelectFileExtCmd value) {
				mm.invoke(AppLogicExtCmd.createOutputFile(value));
			}
		
			public void showMessage(
							 String key
							, MessageDialogParams params
			) {
				mm.invoke( AppLogicExtCmd.createShowMessage(
								ShowMessageCmd.create( 
									key, params)));		
			}
		
			public void closeMainFrame() {
				mm.invoke(AppLogicExtCmd.createCloseMainFrame());
			}
		
			public void exit() {
				mm.invoke(AppLogicExtCmd.createExit());
			}
		
		}
	}
}