package nianio;

import schema.runtime.datatypes.ImmObject;
import nianio.complib.CompLibCommand;
import schema.runtime.err.SchemaException;
import nianio.genrap.GenrapPluginCommand;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class ExternalCommand = variant {
 *	    complib of CompLibCommand  
 *	 |  genrap of GenrapPluginCommand  
 *	 |  exit 
 * }</pre>
 */ 
public class ExternalCommand implements ImmObject {
	private static final int TYPE_HASH = 381747424;
	private int hash = 0;

	private static final ExternalCommand CONST_EXIT = new ExternalCommand(2);
	private final int variant;
	private final Object value;  

	private ExternalCommand(int variant) {
		this.variant = variant;
		this.value = null;
	}

	private ExternalCommand(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static ExternalCommand createComplib(CompLibCommand value) {
		return new ExternalCommand(0, value);
	}

	public static ExternalCommand createGenrap(GenrapPluginCommand value) {
		return new ExternalCommand(1, value);
	}

	public static ExternalCommand createExit() {
		return CONST_EXIT;
	}



	/** @return true, when this is complib */
	public boolean isComplib() {
		return variant == 0;
	}

	/** @return variant value, when this is complib; throws Exception otherwise */
	public CompLibCommand asComplib() {
		SchemaException.ensure(isComplib());
		return (CompLibCommand)value;
	}

	/** @return true, when this is genrap */
	public boolean isGenrap() {
		return variant == 1;
	}

	/** @return variant value, when this is genrap; throws Exception otherwise */
	public GenrapPluginCommand asGenrap() {
		SchemaException.ensure(isGenrap());
		return (GenrapPluginCommand)value;
	}

	/** @return true, when this is exit */
	public boolean isExit() {
		return variant == 2;
	}




	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isComplib()) {
			;
		} else if (isGenrap()) {
			;
		} else if (isExit()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isComplib()) {
			asComplib();
		} else if (isGenrap()) {
			asGenrap();
		} else if (isExit()) {
			;
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isComplib())
			return "complib" + "(" + asComplib() + ")";
		if (isGenrap())
			return "genrap" + "(" + asGenrap() + ")";
		if (isExit())
			return "exit";		
		throw SchemaException.err();
	}
	
	public boolean eq(ExternalCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof ExternalCommand) 
			&& this.eq((ExternalCommand)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for ExternalCommand
	 */
	public static interface MM {
		public void invoke(ExternalCommand cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for ExternalCommand
	 */
	public static interface MMIntf {
		public void complib(CompLibCommand value);
		public void genrap(GenrapPluginCommand value);
		public void exit();
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for ExternalCommand
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(ExternalCommand cmd) {
				 if (cmd.isComplib()) {
					mm.complib(cmd.asComplib());
				} else if (cmd.isGenrap()) {
					mm.genrap(cmd.asGenrap());
				} else if (cmd.isExit()) {
					mm.exit();
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void complib(CompLibCommand value) {
				mm.invoke(ExternalCommand.createComplib(value));
			}
		
			public void genrap(GenrapPluginCommand value) {
				mm.invoke(ExternalCommand.createGenrap(value));
			}
		
			public void exit() {
				mm.invoke(ExternalCommand.createExit());
			}
		
		}
	}
}