package nianio;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.complib.messagedialog.MessageDialogParams;


/** 
 * <pre>Autogenerated class ShowMessageCmd = {
 *		  key  : String
 *		  params  : MessageDialogParams
 * }</pre>
 */ 

public class ShowMessageCmd implements ImmObject {
	private static final int TYPE_HASH = -1098653008;
	private int hash = 0;

	final private String key;
	final private MessageDialogParams params;
			
	private ShowMessageCmd(
		 String key
		, MessageDialogParams params
	) {
		this.key = key;
		this.params = params;
	}
	

	/** Creates a struct record with given values
	 * @param key != null (mandatory)
	 * @param params != null (mandatory)
	 */
	public static ShowMessageCmd create(
		 String key
		, MessageDialogParams params
	) {
		SchemaException.ensure(key != null);
		SchemaException.ensure(params != null);

		return new ShowMessageCmd(
			 key
			, params
		);		
	}


	/* getters */
	
	/** field key, should never return null */
	public String getKey() {
		return this.key;
	}
	/** field params, should never return null */
	public MessageDialogParams getParams() {
		return this.params;
	}

	/* setters */
	
	/** create struct with field key modified, 
	 * (exception when arg==null) */
	public ShowMessageCmd setKey(String key) {	 
		SchemaException.ensure(key != null);
		return new ShowMessageCmd(
			  key 		
			, this.params 		
		);		
	}
	/** create struct with field params modified, 
	 * (exception when arg==null) */
	public ShowMessageCmd setParams(MessageDialogParams params) {	 
		SchemaException.ensure(params != null);
		return new ShowMessageCmd(
			  this.key 		
			, params 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof ShowMessageCmd) 
			&& this.eq((ShowMessageCmd)obj);
	}
	
	public boolean eq(ShowMessageCmd obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqKey(this, obj)
			&& eqParams(this, obj)
			;
	}

	private static boolean eqKey(ShowMessageCmd o1, ShowMessageCmd o2) {
		String f1 = o1.getKey();
		String f2 = o2.getKey();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqParams(ShowMessageCmd o1, ShowMessageCmd o2) {
		MessageDialogParams f1 = o1.getParams();
		MessageDialogParams f2 = o2.getParams();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("key" + "=");
		out.append(getKey());
		out.append(", ");
		out.append("params" + "=");
		out.append(getParams());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.key.hashCode() + 1227380495;
			h ^= this.params.hashCode() + 1975075542;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}