package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.FrameId;


/** 
 * <pre>Autogenerated class FrameState = {
 *		  id  : FrameId
 *		  title  : String
 *		  isResizable  : boolean
 *		  content  : CompState
 * }</pre>
 */ 

public class FrameState implements ImmObject {
	private static final int TYPE_HASH = 1711858500;
	private int hash = 0;

	final private FrameId id;
	final private String title;
	final private boolean isResizable;
	final private CompState content;
			
	private FrameState(
		 FrameId id
		, String title
		, boolean isResizable
		, CompState content
	) {
		this.id = id;
		this.title = title;
		this.isResizable = isResizable;
		this.content = content;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param title != null (mandatory)
	 * @param isResizable != null (mandatory)
	 * @param content != null (mandatory)
	 */
	public static FrameState create(
		 FrameId id
		, String title
		, boolean isResizable
		, CompState content
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(title != null);
		SchemaException.ensure(true);
		SchemaException.ensure(content != null);

		return new FrameState(
			 id
			, title
			, isResizable
			, content
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public FrameId getId() {
		return this.id;
	}
	/** field title, should never return null */
	public String getTitle() {
		return this.title;
	}
	/** field isResizable, should never return null */
	public boolean getIsResizable() {
		return this.isResizable;
	}
	/** field content, should never return null */
	public CompState getContent() {
		return this.content;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public FrameState setId(FrameId id) {	 
		SchemaException.ensure(id != null);
		return new FrameState(
			  id 		
			, this.title 		
			, this.isResizable 		
			, this.content 		
		);		
	}
	/** create struct with field title modified, 
	 * (exception when arg==null) */
	public FrameState setTitle(String title) {	 
		SchemaException.ensure(title != null);
		return new FrameState(
			  this.id 		
			, title 		
			, this.isResizable 		
			, this.content 		
		);		
	}
	/** create struct with field isResizable modified, 
	 * (exception when arg==null) */
	public FrameState setIsResizable(boolean isResizable) {	 
		SchemaException.ensure(true);
		return new FrameState(
			  this.id 		
			, this.title 		
			, isResizable 		
			, this.content 		
		);		
	}
	/** create struct with field content modified, 
	 * (exception when arg==null) */
	public FrameState setContent(CompState content) {	 
		SchemaException.ensure(content != null);
		return new FrameState(
			  this.id 		
			, this.title 		
			, this.isResizable 		
			, content 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof FrameState) 
			&& this.eq((FrameState)obj);
	}
	
	public boolean eq(FrameState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqTitle(this, obj)
			&& eqIsResizable(this, obj)
			&& eqContent(this, obj)
			;
	}

	private static boolean eqId(FrameState o1, FrameState o2) {
		FrameId f1 = o1.getId();
		FrameId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqTitle(FrameState o1, FrameState o2) {
		String f1 = o1.getTitle();
		String f2 = o2.getTitle();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqIsResizable(FrameState o1, FrameState o2) {
		boolean f1 = o1.getIsResizable();
		boolean f2 = o2.getIsResizable();
		return 	f1 == f2;
	}
	private static boolean eqContent(FrameState o1, FrameState o2) {
		CompState f1 = o1.getContent();
		CompState f2 = o2.getContent();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("title" + "=");
		out.append(getTitle());
		out.append(", ");
		out.append("isResizable" + "=");
		out.append(getIsResizable());
		out.append(", ");
		out.append("content" + "=");
		out.append(getContent());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.title.hashCode() + -1594921208;
			h ^= this.isResizable ? -1475957423 : 1475957422;
			h ^= this.content.hashCode() + -1452141271;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}