package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.PanelId;


/** 
 * <pre>Autogenerated class PanelState = {
 *		  id  : PanelId
 *		  layout  : Layout
 *		  comps  : Comps
 * }</pre>
 */ 

public class PanelState implements ImmObject {
	private static final int TYPE_HASH = -1014281971;
	private int hash = 0;

	final private PanelId id;
	final private Layout layout;
	final private Comps comps;
			
	private PanelState(
		 PanelId id
		, Layout layout
		, Comps comps
	) {
		this.id = id;
		this.layout = layout;
		this.comps = comps;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param layout != null (mandatory)
	 * @param comps != null (mandatory)
	 */
	public static PanelState create(
		 PanelId id
		, Layout layout
		, Comps comps
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(layout != null);
		SchemaException.ensure(comps != null);

		return new PanelState(
			 id
			, layout
			, comps
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public PanelId getId() {
		return this.id;
	}
	/** field layout, should never return null */
	public Layout getLayout() {
		return this.layout;
	}
	/** field comps, should never return null */
	public Comps getComps() {
		return this.comps;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public PanelState setId(PanelId id) {	 
		SchemaException.ensure(id != null);
		return new PanelState(
			  id 		
			, this.layout 		
			, this.comps 		
		);		
	}
	/** create struct with field layout modified, 
	 * (exception when arg==null) */
	public PanelState setLayout(Layout layout) {	 
		SchemaException.ensure(layout != null);
		return new PanelState(
			  this.id 		
			, layout 		
			, this.comps 		
		);		
	}
	/** create struct with field comps modified, 
	 * (exception when arg==null) */
	public PanelState setComps(Comps comps) {	 
		SchemaException.ensure(comps != null);
		return new PanelState(
			  this.id 		
			, this.layout 		
			, comps 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof PanelState) 
			&& this.eq((PanelState)obj);
	}
	
	public boolean eq(PanelState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqLayout(this, obj)
			&& eqComps(this, obj)
			;
	}

	private static boolean eqId(PanelState o1, PanelState o2) {
		PanelId f1 = o1.getId();
		PanelId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqLayout(PanelState o1, PanelState o2) {
		Layout f1 = o1.getLayout();
		Layout f2 = o2.getLayout();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqComps(PanelState o1, PanelState o2) {
		Comps f1 = o1.getComps();
		Comps f2 = o2.getComps();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("layout" + "=");
		out.append(getLayout());
		out.append(", ");
		out.append("comps" + "=");
		out.append(getComps());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.layout.hashCode() + 1860781178;
			h ^= this.comps.hashCode() + -1610448908;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}