package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import nianio.ids.FrameId;


/** 
 * <pre>Autogenerated class ShownFrameIdCommand = {
 *		  id  : FrameId
 *		  cmd  : ShownFrameCommand
 * }</pre>
 */ 

public class ShownFrameIdCommand implements ImmObject {
	private static final int TYPE_HASH = 457027092;
	private int hash = 0;

	final private FrameId id;
	final private ShownFrameCommand cmd;
			
	private ShownFrameIdCommand(
		 FrameId id
		, ShownFrameCommand cmd
	) {
		this.id = id;
		this.cmd = cmd;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param cmd != null (mandatory)
	 */
	public static ShownFrameIdCommand create(
		 FrameId id
		, ShownFrameCommand cmd
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(cmd != null);

		return new ShownFrameIdCommand(
			 id
			, cmd
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public FrameId getId() {
		return this.id;
	}
	/** field cmd, should never return null */
	public ShownFrameCommand getCmd() {
		return this.cmd;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public ShownFrameIdCommand setId(FrameId id) {	 
		SchemaException.ensure(id != null);
		return new ShownFrameIdCommand(
			  id 		
			, this.cmd 		
		);		
	}
	/** create struct with field cmd modified, 
	 * (exception when arg==null) */
	public ShownFrameIdCommand setCmd(ShownFrameCommand cmd) {	 
		SchemaException.ensure(cmd != null);
		return new ShownFrameIdCommand(
			  this.id 		
			, cmd 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof ShownFrameIdCommand) 
			&& this.eq((ShownFrameIdCommand)obj);
	}
	
	public boolean eq(ShownFrameIdCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqCmd(this, obj)
			;
	}

	private static boolean eqId(ShownFrameIdCommand o1, ShownFrameIdCommand o2) {
		FrameId f1 = o1.getId();
		FrameId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCmd(ShownFrameIdCommand o1, ShownFrameIdCommand o2) {
		ShownFrameCommand f1 = o1.getCmd();
		ShownFrameCommand f2 = o2.getCmd();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("cmd" + "=");
		out.append(getCmd());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.cmd.hashCode() + 1227373034;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}