package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class UniLayoutParams = {
 *		  cols  : int
 *		  rows  : int
 *		  hGap  : int
 *		  vGap  : int
 * }</pre>
 */ 

public class UniLayoutParams implements ImmObject {
	private static final int TYPE_HASH = 720912960;
	private int hash = 0;

	final private int cols;
	final private int rows;
	final private int hGap;
	final private int vGap;
			
	private UniLayoutParams(
		 int cols
		, int rows
		, int hGap
		, int vGap
	) {
		this.cols = cols;
		this.rows = rows;
		this.hGap = hGap;
		this.vGap = vGap;
	}
	

	/** Creates a struct record with given values
	 * @param cols != null (mandatory)
	 * @param rows != null (mandatory)
	 * @param hGap != null (mandatory)
	 * @param vGap != null (mandatory)
	 */
	public static UniLayoutParams create(
		 int cols
		, int rows
		, int hGap
		, int vGap
	) {
		SchemaException.ensure(true);
		SchemaException.ensure(true);
		SchemaException.ensure(true);
		SchemaException.ensure(true);

		return new UniLayoutParams(
			 cols
			, rows
			, hGap
			, vGap
		);		
	}


	/* getters */
	
	/** field cols, should never return null */
	public int getCols() {
		return this.cols;
	}
	/** field rows, should never return null */
	public int getRows() {
		return this.rows;
	}
	/** field hGap, should never return null */
	public int getHGap() {
		return this.hGap;
	}
	/** field vGap, should never return null */
	public int getVGap() {
		return this.vGap;
	}

	/* setters */
	
	/** create struct with field cols modified, 
	 * (exception when arg==null) */
	public UniLayoutParams setCols(int cols) {	 
		SchemaException.ensure(true);
		return new UniLayoutParams(
			  cols 		
			, this.rows 		
			, this.hGap 		
			, this.vGap 		
		);		
	}
	/** create struct with field rows modified, 
	 * (exception when arg==null) */
	public UniLayoutParams setRows(int rows) {	 
		SchemaException.ensure(true);
		return new UniLayoutParams(
			  this.cols 		
			, rows 		
			, this.hGap 		
			, this.vGap 		
		);		
	}
	/** create struct with field hGap modified, 
	 * (exception when arg==null) */
	public UniLayoutParams setHGap(int hGap) {	 
		SchemaException.ensure(true);
		return new UniLayoutParams(
			  this.cols 		
			, this.rows 		
			, hGap 		
			, this.vGap 		
		);		
	}
	/** create struct with field vGap modified, 
	 * (exception when arg==null) */
	public UniLayoutParams setVGap(int vGap) {	 
		SchemaException.ensure(true);
		return new UniLayoutParams(
			  this.cols 		
			, this.rows 		
			, this.hGap 		
			, vGap 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof UniLayoutParams) 
			&& this.eq((UniLayoutParams)obj);
	}
	
	public boolean eq(UniLayoutParams obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqCols(this, obj)
			&& eqRows(this, obj)
			&& eqHGap(this, obj)
			&& eqVGap(this, obj)
			;
	}

	private static boolean eqCols(UniLayoutParams o1, UniLayoutParams o2) {
		int f1 = o1.getCols();
		int f2 = o2.getCols();
		return 	f1 == f2;
	}
	private static boolean eqRows(UniLayoutParams o1, UniLayoutParams o2) {
		int f1 = o1.getRows();
		int f2 = o2.getRows();
		return 	f1 == f2;
	}
	private static boolean eqHGap(UniLayoutParams o1, UniLayoutParams o2) {
		int f1 = o1.getHGap();
		int f2 = o2.getHGap();
		return 	f1 == f2;
	}
	private static boolean eqVGap(UniLayoutParams o1, UniLayoutParams o2) {
		int f1 = o1.getVGap();
		int f2 = o2.getVGap();
		return 	f1 == f2;
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("cols" + "=");
		out.append(getCols());
		out.append(", ");
		out.append("rows" + "=");
		out.append(getRows());
		out.append(", ");
		out.append("hGap" + "=");
		out.append(getHGap());
		out.append(", ");
		out.append("vGap" + "=");
		out.append(getVGap());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= (this.cols) + -606139325;
			h ^= (this.rows) + -605692119;
			h ^= (this.hGap) + -606029154;
			h ^= (this.vGap) + -605612080;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}