package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.UserDialogId;
import schema.runtime.err.SchemaException;
import nianio.ids.WindowId;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class UserDialogCommand = variant {
 *	    createDialog of DialogState  
 *	 |  dialog of CreatedDialogCommand  
 * }</pre>
 */ 
public class UserDialogCommand implements ImmObject {
	private static final int TYPE_HASH = -759972168;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private UserDialogCommand(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static UserDialogCommand createCreateDialog(DialogState value) {
		return new UserDialogCommand(0, value);
	}

	public static UserDialogCommand createDialog(CreatedDialogCommand value) {
		return new UserDialogCommand(1, value);
	}


	public static UserDialogCommand mkCreateDialog(
			UserDialogId id
			, WindowId parentId
			, String title
			, boolean isModal
			, boolean isResizable
			, CompState content
	) {
		return createCreateDialog( DialogState.create(
							id
							, parentId
							, title
							, isModal
							, isResizable
							, content
							 ));
	}
	

	/** @return true, when this is createDialog */
	public boolean isCreateDialog() {
		return variant == 0;
	}

	/** @return variant value, when this is createDialog; throws Exception otherwise */
	public DialogState asCreateDialog() {
		SchemaException.ensure(isCreateDialog());
		return (DialogState)value;
	}

	/** @return true, when this is dialog */
	public boolean isDialog() {
		return variant == 1;
	}

	/** @return variant value, when this is dialog; throws Exception otherwise */
	public CreatedDialogCommand asDialog() {
		SchemaException.ensure(isDialog());
		return (CreatedDialogCommand)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isCreateDialog()) {
			;
		} else if (isDialog()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isCreateDialog()) {
			asCreateDialog();
		} else if (isDialog()) {
			asDialog();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isCreateDialog())
			return "createDialog" + "(" + asCreateDialog() + ")";
		if (isDialog())
			return "dialog" + "(" + asDialog() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(UserDialogCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof UserDialogCommand) 
			&& this.eq((UserDialogCommand)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	
}