package nianio.complib;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.UserDialogId;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class UserDialogIdEvent = {
 *		  id  : UserDialogId
 *		  event  : UserDialogEvent
 * }</pre>
 */ 

public class UserDialogIdEvent implements ImmObject {
	private static final int TYPE_HASH = -81506900;
	private int hash = 0;

	final private UserDialogId id;
	final private UserDialogEvent event;
			
	private UserDialogIdEvent(
		 UserDialogId id
		, UserDialogEvent event
	) {
		this.id = id;
		this.event = event;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param event != null (mandatory)
	 */
	public static UserDialogIdEvent create(
		 UserDialogId id
		, UserDialogEvent event
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(event != null);

		return new UserDialogIdEvent(
			 id
			, event
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public UserDialogId getId() {
		return this.id;
	}
	/** field event, should never return null */
	public UserDialogEvent getEvent() {
		return this.event;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public UserDialogIdEvent setId(UserDialogId id) {	 
		SchemaException.ensure(id != null);
		return new UserDialogIdEvent(
			  id 		
			, this.event 		
		);		
	}
	/** create struct with field event modified, 
	 * (exception when arg==null) */
	public UserDialogIdEvent setEvent(UserDialogEvent event) {	 
		SchemaException.ensure(event != null);
		return new UserDialogIdEvent(
			  this.id 		
			, event 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof UserDialogIdEvent) 
			&& this.eq((UserDialogIdEvent)obj);
	}
	
	public boolean eq(UserDialogIdEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqEvent(this, obj)
			;
	}

	private static boolean eqId(UserDialogIdEvent o1, UserDialogIdEvent o2) {
		UserDialogId f1 = o1.getId();
		UserDialogId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqEvent(UserDialogIdEvent o1, UserDialogIdEvent o2) {
		UserDialogEvent f1 = o1.getEvent();
		UserDialogEvent f2 = o2.getEvent();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("event" + "=");
		out.append(getEvent());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.event.hashCode() + -1608401078;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}