package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class ButtonCommand =
 * variant (enumeration) {
 *	    enable 
 *	 |  disable 
 * }
 */ 
public class ButtonCommand implements ImmObject {
	private static final int TYPE_HASH = -1288936551;


	private static final ButtonCommand CONST_ENABLE = new ButtonCommand(0);
	private static final ButtonCommand CONST_DISABLE = new ButtonCommand(1);

	private final int variant;

	private ButtonCommand(int variant) {
		this.variant = variant;
	}


	public static ButtonCommand createEnable() {
		return CONST_ENABLE;
	}
	
	public static ButtonCommand createDisable() {
		return CONST_DISABLE;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isEnable()) {
			;
		} else if (isDisable()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is enable */
	public boolean isEnable() {
		return variant == 0;
	}

	/** @return true, when this is disable */
	public boolean isDisable() {
		return variant == 1;
	}




	public String toString() {
		if (isEnable())
			return "enable";
		if (isDisable())
			return "disable";
		throw SchemaException.err();
	}
	
	public boolean eq(ButtonCommand obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof ButtonCommand) 
			&& this.eq((ButtonCommand)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for ButtonCommand
	 */
	public static interface MM {
		public void invoke(ButtonCommand cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for ButtonCommand
	 */
	public static interface MMIntf {
		public void enable();
		public void disable();
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for ButtonCommand
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(ButtonCommand cmd) {
				 if (cmd.isEnable()) {
					mm.enable();
				} else if (cmd.isDisable()) {
					mm.disable();
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void enable() {
				mm.invoke(ButtonCommand.createEnable());
			}
		
			public void disable() {
				mm.invoke(ButtonCommand.createDisable());
			}
		
		}
	}
}