package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class ButtonEvent =
 * variant (enumeration) {
 *	    fired 
 * }
 */ 
public class ButtonEvent implements ImmObject {
	private static final int TYPE_HASH = -115494296;


	private static final ButtonEvent CONST_FIRED = new ButtonEvent(0);

	private final int variant;

	private ButtonEvent(int variant) {
		this.variant = variant;
	}


	public static ButtonEvent createFired() {
		return CONST_FIRED;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isFired()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is fired */
	public boolean isFired() {
		return variant == 0;
	}




	public String toString() {
		if (isFired())
			return "fired";
		throw SchemaException.err();
	}
	
	public boolean eq(ButtonEvent obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof ButtonEvent) 
			&& this.eq((ButtonEvent)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for ButtonEvent
	 */
	public static interface MM {
		public void invoke(ButtonEvent cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for ButtonEvent
	 */
	public static interface MMIntf {
		public void fired();
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for ButtonEvent
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(ButtonEvent cmd) {
				 if (cmd.isFired()) {
					mm.fired();
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void fired() {
				mm.invoke(ButtonEvent.createFired());
			}
		
		}
	}
}