package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class LabelCommand = variant {
 *	    setText of String  
 * }</pre>
 */ 
public class LabelCommand implements ImmObject {
	private static final int TYPE_HASH = 627003863;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private LabelCommand(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static LabelCommand createSetText(String value) {
		return new LabelCommand(0, value);
	}



	/** @return true, when this is setText */
	public boolean isSetText() {
		return variant == 0;
	}

	/** @return variant value, when this is setText; throws Exception otherwise */
	public String asSetText() {
		SchemaException.ensure(isSetText());
		return ((String)value);
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isSetText()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isSetText()) {
			asSetText();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isSetText())
			return "setText" + "(" + asSetText() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(LabelCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof LabelCommand) 
			&& this.eq((LabelCommand)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for LabelCommand
	 */
	public static interface MM {
		public void invoke(LabelCommand cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for LabelCommand
	 */
	public static interface MMIntf {
		public void setText(String value);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for LabelCommand
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(LabelCommand cmd) {
				 if (cmd.isSetText()) {
					mm.setText(cmd.asSetText());
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void setText(String value) {
				mm.invoke(LabelCommand.createSetText(value));
			}
		
		}
	}
}