package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * Autogenerated class RadioButtonCommand =
 * variant (enumeration) {
 *	    select 
 *	 |  unselect 
 *	 |  enable 
 *	 |  disable 
 * }
 */ 
public class RadioButtonCommand implements ImmObject {
	private static final int TYPE_HASH = 560438174;


	private static final RadioButtonCommand CONST_SELECT = new RadioButtonCommand(0);
	private static final RadioButtonCommand CONST_UNSELECT = new RadioButtonCommand(1);
	private static final RadioButtonCommand CONST_ENABLE = new RadioButtonCommand(2);
	private static final RadioButtonCommand CONST_DISABLE = new RadioButtonCommand(3);

	private final int variant;

	private RadioButtonCommand(int variant) {
		this.variant = variant;
	}


	public static RadioButtonCommand createSelect() {
		return CONST_SELECT;
	}
	
	public static RadioButtonCommand createUnselect() {
		return CONST_UNSELECT;
	}
	
	public static RadioButtonCommand createEnable() {
		return CONST_ENABLE;
	}
	
	public static RadioButtonCommand createDisable() {
		return CONST_DISABLE;
	}
	

	/* The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isSelect()) {
			;
		} else if (isUnselect()) {
			;
		} else if (isEnable()) {
			;
		} else if (isDisable()) {
			;
		} else 		
			throw Err.errM(this);
	}


	/** @return true, when this is select */
	public boolean isSelect() {
		return variant == 0;
	}

	/** @return true, when this is unselect */
	public boolean isUnselect() {
		return variant == 1;
	}

	/** @return true, when this is enable */
	public boolean isEnable() {
		return variant == 2;
	}

	/** @return true, when this is disable */
	public boolean isDisable() {
		return variant == 3;
	}




	public String toString() {
		if (isSelect())
			return "select";
		if (isUnselect())
			return "unselect";
		if (isEnable())
			return "enable";
		if (isDisable())
			return "disable";
		throw SchemaException.err();
	}
	
	public boolean eq(RadioButtonCommand obj) {
		if (obj == null)
			return false;
		return variant == obj.variant;
	}
	
	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonCommand) 
			&& this.eq((RadioButtonCommand)obj);
	}

	public int hashCode(){
		return (variant*(variant-79) + 1601) ^ TYPE_HASH;
	}

 
		

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for RadioButtonCommand
	 */
	public static interface MM {
		public void invoke(RadioButtonCommand cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for RadioButtonCommand
	 */
	public static interface MMIntf {
		public void select();
		public void unselect();
		public void enable();
		public void disable();
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for RadioButtonCommand
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(RadioButtonCommand cmd) {
				 if (cmd.isSelect()) {
					mm.select();
				} else if (cmd.isUnselect()) {
					mm.unselect();
				} else if (cmd.isEnable()) {
					mm.enable();
				} else if (cmd.isDisable()) {
					mm.disable();
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void select() {
				mm.invoke(RadioButtonCommand.createSelect());
			}
		
			public void unselect() {
				mm.invoke(RadioButtonCommand.createUnselect());
			}
		
			public void enable() {
				mm.invoke(RadioButtonCommand.createEnable());
			}
		
			public void disable() {
				mm.invoke(RadioButtonCommand.createDisable());
			}
		
		}
	}
}