package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.RadioButtonId;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class RadioButtonIdCommand = {
 *		  id  : RadioButtonId
 *		  cmd  : RadioButtonCommand
 * }</pre>
 */ 

public class RadioButtonIdCommand implements ImmObject {
	private static final int TYPE_HASH = -1087801021;
	private int hash = 0;

	final private RadioButtonId id;
	final private RadioButtonCommand cmd;
			
	private RadioButtonIdCommand(
		 RadioButtonId id
		, RadioButtonCommand cmd
	) {
		this.id = id;
		this.cmd = cmd;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param cmd != null (mandatory)
	 */
	public static RadioButtonIdCommand create(
		 RadioButtonId id
		, RadioButtonCommand cmd
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(cmd != null);

		return new RadioButtonIdCommand(
			 id
			, cmd
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public RadioButtonId getId() {
		return this.id;
	}
	/** field cmd, should never return null */
	public RadioButtonCommand getCmd() {
		return this.cmd;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public RadioButtonIdCommand setId(RadioButtonId id) {	 
		SchemaException.ensure(id != null);
		return new RadioButtonIdCommand(
			  id 		
			, this.cmd 		
		);		
	}
	/** create struct with field cmd modified, 
	 * (exception when arg==null) */
	public RadioButtonIdCommand setCmd(RadioButtonCommand cmd) {	 
		SchemaException.ensure(cmd != null);
		return new RadioButtonIdCommand(
			  this.id 		
			, cmd 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof RadioButtonIdCommand) 
			&& this.eq((RadioButtonIdCommand)obj);
	}
	
	public boolean eq(RadioButtonIdCommand obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqCmd(this, obj)
			;
	}

	private static boolean eqId(RadioButtonIdCommand o1, RadioButtonIdCommand o2) {
		RadioButtonId f1 = o1.getId();
		RadioButtonId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqCmd(RadioButtonIdCommand o1, RadioButtonIdCommand o2) {
		RadioButtonCommand f1 = o1.getCmd();
		RadioButtonCommand f2 = o2.getCmd();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("cmd" + "=");
		out.append(getCmd());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= this.cmd.hashCode() + 1227373034;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}