package nianio.complib.controls;

import schema.runtime.datatypes.ImmObject;
import nianio.ids.TextBoxId;
import schema.runtime.err.SchemaException;


/** 
 * <pre>Autogenerated class TextBoxState = {
 *		  id  : TextBoxId
 *		  rows  : int
 *		  cols  : int
 *		  text  : String
 *		  password  : boolean
 *		  preserveSelection  : boolean
 * }</pre>
 */ 

public class TextBoxState implements ImmObject {
	private static final int TYPE_HASH = 2137177587;
	private int hash = 0;

	final private TextBoxId id;
	final private int rows;
	final private int cols;
	final private String text;
	final private boolean password;
	final private boolean preserveSelection;
			
	private TextBoxState(
		 TextBoxId id
		, int rows
		, int cols
		, String text
		, boolean password
		, boolean preserveSelection
	) {
		this.id = id;
		this.rows = rows;
		this.cols = cols;
		this.text = text;
		this.password = password;
		this.preserveSelection = preserveSelection;
	}
	

	/** Creates a struct record with given values
	 * @param id != null (mandatory)
	 * @param rows != null (mandatory)
	 * @param cols != null (mandatory)
	 * @param text != null (mandatory)
	 * @param password != null (mandatory)
	 * @param preserveSelection != null (mandatory)
	 */
	public static TextBoxState create(
		 TextBoxId id
		, int rows
		, int cols
		, String text
		, boolean password
		, boolean preserveSelection
	) {
		SchemaException.ensure(id != null);
		SchemaException.ensure(true);
		SchemaException.ensure(true);
		SchemaException.ensure(text != null);
		SchemaException.ensure(true);
		SchemaException.ensure(true);

		return new TextBoxState(
			 id
			, rows
			, cols
			, text
			, password
			, preserveSelection
		);		
	}


	/* getters */
	
	/** field id, should never return null */
	public TextBoxId getId() {
		return this.id;
	}
	/** field rows, should never return null */
	public int getRows() {
		return this.rows;
	}
	/** field cols, should never return null */
	public int getCols() {
		return this.cols;
	}
	/** field text, should never return null */
	public String getText() {
		return this.text;
	}
	/** field password, should never return null */
	public boolean getPassword() {
		return this.password;
	}
	/** field preserveSelection, should never return null */
	public boolean getPreserveSelection() {
		return this.preserveSelection;
	}

	/* setters */
	
	/** create struct with field id modified, 
	 * (exception when arg==null) */
	public TextBoxState setId(TextBoxId id) {	 
		SchemaException.ensure(id != null);
		return new TextBoxState(
			  id 		
			, this.rows 		
			, this.cols 		
			, this.text 		
			, this.password 		
			, this.preserveSelection 		
		);		
	}
	/** create struct with field rows modified, 
	 * (exception when arg==null) */
	public TextBoxState setRows(int rows) {	 
		SchemaException.ensure(true);
		return new TextBoxState(
			  this.id 		
			, rows 		
			, this.cols 		
			, this.text 		
			, this.password 		
			, this.preserveSelection 		
		);		
	}
	/** create struct with field cols modified, 
	 * (exception when arg==null) */
	public TextBoxState setCols(int cols) {	 
		SchemaException.ensure(true);
		return new TextBoxState(
			  this.id 		
			, this.rows 		
			, cols 		
			, this.text 		
			, this.password 		
			, this.preserveSelection 		
		);		
	}
	/** create struct with field text modified, 
	 * (exception when arg==null) */
	public TextBoxState setText(String text) {	 
		SchemaException.ensure(text != null);
		return new TextBoxState(
			  this.id 		
			, this.rows 		
			, this.cols 		
			, text 		
			, this.password 		
			, this.preserveSelection 		
		);		
	}
	/** create struct with field password modified, 
	 * (exception when arg==null) */
	public TextBoxState setPassword(boolean password) {	 
		SchemaException.ensure(true);
		return new TextBoxState(
			  this.id 		
			, this.rows 		
			, this.cols 		
			, this.text 		
			, password 		
			, this.preserveSelection 		
		);		
	}
	/** create struct with field preserveSelection modified, 
	 * (exception when arg==null) */
	public TextBoxState setPreserveSelection(boolean preserveSelection) {	 
		SchemaException.ensure(true);
		return new TextBoxState(
			  this.id 		
			, this.rows 		
			, this.cols 		
			, this.text 		
			, this.password 		
			, preserveSelection 		
		);		
	}
	


	public boolean equals(Object obj) {
		return (obj instanceof TextBoxState) 
			&& this.eq((TextBoxState)obj);
	}
	
	public boolean eq(TextBoxState obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return true
			&& eqId(this, obj)
			&& eqRows(this, obj)
			&& eqCols(this, obj)
			&& eqText(this, obj)
			&& eqPassword(this, obj)
			&& eqPreserveSelection(this, obj)
			;
	}

	private static boolean eqId(TextBoxState o1, TextBoxState o2) {
		TextBoxId f1 = o1.getId();
		TextBoxId f2 = o2.getId();
		return 	f1==null ? (f2==null) : (f2!=null && f1.eq(f2));
	}
	private static boolean eqRows(TextBoxState o1, TextBoxState o2) {
		int f1 = o1.getRows();
		int f2 = o2.getRows();
		return 	f1 == f2;
	}
	private static boolean eqCols(TextBoxState o1, TextBoxState o2) {
		int f1 = o1.getCols();
		int f2 = o2.getCols();
		return 	f1 == f2;
	}
	private static boolean eqText(TextBoxState o1, TextBoxState o2) {
		String f1 = o1.getText();
		String f2 = o2.getText();
		return 	f1==null ? (f2==null) : (f2!=null && f1.equals(f2));
	}
	private static boolean eqPassword(TextBoxState o1, TextBoxState o2) {
		boolean f1 = o1.getPassword();
		boolean f2 = o2.getPassword();
		return 	f1 == f2;
	}
	private static boolean eqPreserveSelection(TextBoxState o1, TextBoxState o2) {
		boolean f1 = o1.getPreserveSelection();
		boolean f2 = o2.getPreserveSelection();
		return 	f1 == f2;
	}
	
	public String toString() {
		StringBuffer out = new StringBuffer();		
		out.append("{");
		out.append("id" + "=");
		out.append(getId());
		out.append(", ");
		out.append("rows" + "=");
		out.append(getRows());
		out.append(", ");
		out.append("cols" + "=");
		out.append(getCols());
		out.append(", ");
		out.append("text" + "=");
		out.append(getText());
		out.append(", ");
		out.append("password" + "=");
		out.append(getPassword());
		out.append(", ");
		out.append("preserveSelection" + "=");
		out.append(getPreserveSelection());
		out.append("}");
		return out.toString();
	}

	public int hashCode(){
		if (hash == 0) {
			int h = TYPE_HASH;
			h ^= this.id.hashCode() + -1345880469;
			h ^= (this.rows) + -605692119;
			h ^= (this.cols) + -606139325;
			h ^= this.text.hashCode() + -605642115;
			h ^= this.password ? -282398741 : 282398740;
			h ^= this.preserveSelection ? 196214096 : -196214097;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
}