package nianio.complib.filechooser;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import schema.runtime.internal.datatypes.ObjectArray;


/** 
 * <pre>array of String
 * Autogenerated class Extensions
 * </pre>
 */ 
public class Extensions implements ImmObject {
	public static final Extensions EMPTY = new Extensions();

	private final ObjectArray arr;
	
	private Extensions(ObjectArray arr) {
		this.arr = arr;
	}
	
	public Extensions() {
		this(ObjectArray.ZERO);
	}
	
	public boolean eq(Extensions obj) {
		return arr.equals(obj.arr);
	}

	public boolean equals(Object obj) {
		return (obj instanceof Extensions) 
				&& eq((Extensions)obj);
	}
	
	public int size() {
		return arr.size();
	}

	public Extensions add(String elem) {
		SchemaException.ensure(elem != null);
		return new Extensions(arr.add(elem));
	}

	public Extensions put(int i, String elem) {
		SchemaException.ensure(elem != null);
		return new Extensions(arr.put(i, elem));
	}

	public Extensions insert(int pos, String elem) {
		SchemaException.ensure(elem != null);
		return new Extensions(arr.insert(pos, elem));
	}

	public Extensions remove(int index) {
		return new Extensions(arr.remove(index));
	}

	public Extensions move(int oldpos, int newpos) {
		return new Extensions(arr.move(oldpos, newpos));
	}

	public Extensions concat(Extensions obj) {
		Extensions res = this;
		for(int i = 0; i < obj.size(); ++i)
			res = res.add(obj.get(i));
		return res;
	}

	public String get(int ix) {
		String elem = (String) (arr.get(ix));
		return elem;
	}
	
	public int find(String elem) {
		return arr.find(elem);
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for (int i = 0; i < size(); i++) {
			sb.append(get(i));
			if (i < size()-1)
				sb.append(", ");
		}
		sb.append("]");
		return sb.toString();
	}

	public int hashCode(){
		return arr.hashCode();
	}

 
}
