package nianio.complib.filechooser;

import schema.runtime.datatypes.ImmObject;
import schema.runtime.err.SchemaException;
import ocean.common.Err;


/** 
 * <pre>Autogenerated class FileChooserEvent = variant {
 *	    fileSelected of FileChooserResult  
 * }</pre>
 */ 
public class FileChooserEvent implements ImmObject {
	private static final int TYPE_HASH = -241732133;
	private int hash = 0;

	private final int variant;
	private final Object value;  


	private FileChooserEvent(int variant, Object value) {
		SchemaException.ensure(value != null);
		this.variant = variant;
		this.value = value;
	}


	public static FileChooserEvent createFileSelected(FileChooserResult value) {
		return new FileChooserEvent(0, value);
	}


	public static FileChooserEvent mkFileSelected(
			String pathOrNull
	) {
		return createFileSelected( FileChooserResult.create(
							pathOrNull
							 ));
	}
	

	/** @return true, when this is fileSelected */
	public boolean isFileSelected() {
		return variant == 0;
	}

	/** @return variant value, when this is fileSelected; throws Exception otherwise */
	public FileChooserResult asFileSelected() {
		SchemaException.ensure(isFileSelected());
		return (FileChooserResult)value;
	}



	/** The only purpose of this method is to inline its content - match pattern. */ 
	public void match() {
		if (isFileSelected()) {
			;
		} else 		
			throw Err.errM(this);
	}

	/** The only purpose of this method is to inline its content - 
	 * match pattern with value unpacking. 
	 */ 
	public void matchUnpack() {
		if (isFileSelected()) {
			asFileSelected();
		} else 		
			throw Err.errM(this);
	}	

	public String toString() {
		if (isFileSelected())
			return "fileSelected" + "(" + asFileSelected() + ")";
		throw SchemaException.err();
	}
	
	public boolean eq(FileChooserEvent obj) {
		if (obj == null)
			return false;
		if (this == obj)
			return true;
		return variant == obj.variant 
			&& (value == null ? (obj.value == null) 
			: (obj.value != null && value.equals(obj.value)));
	}

	public boolean equals(Object obj) {
		return (obj instanceof FileChooserEvent) 
			&& this.eq((FileChooserEvent)obj);
	}

	public int hashCode(){
		if (hash == 0) {
			int h = variant*(variant - 79) + 1601;
			if (value != null)
				h ^= value.hashCode();
			else
				h ^= TYPE_HASH;
			hash = h == 0 ? TYPE_HASH : h;
		}
		return hash;
	}

 	
	

	// --------------- Model Manipulator Infrastructure ----------------- //

	/**
	 *  Autogenerated Model Manipulator for FileChooserEvent
	 */
	public static interface MM {
		public void invoke(FileChooserEvent cmd);
	}
	/**
	 *  Autogenerated Model Manipulator Interface for FileChooserEvent
	 */
	public static interface MMIntf {
		public void fileSelected(
				 String pathOrNull
		);
 	}
	/**
	 *  Autogenerated Model Manipulator Converter for FileChooserEvent
	 */
	public static class MMConv {
		public static MMIntf asIntf(MM mm) {
			return new MyMMIntf(mm);
		}
	
		public static MM asSimple(MMIntf mm) {
			return new MyMM(mm);
		}
	
		private static class MyMM implements MM {
	
			private final MMIntf mm;
	
			public MyMM(MMIntf mm) {
				this.mm = mm;
			}
	
			public void invoke(FileChooserEvent cmd) {
				 if (cmd.isFileSelected()) {
					FileChooserResult val = cmd.asFileSelected();
					mm.fileSelected(
							 val.tryGetPath()
					);
				 } else
					throw ocean.common.Err.err();				
			}
		}

		private static class MyMMIntf implements MMIntf {
			private final MM mm;
	
			public MyMMIntf(MM mm) {
				this.mm = mm;
			}
		
			public void fileSelected(
							 String pathOrNull
			) {
				mm.invoke( FileChooserEvent.createFileSelected(
								FileChooserResult.create( 
									pathOrNull)));		
			}
		
		}
	}
}