#!/bin/bash
#set -e

SRCTMP=$1
ITI=$2
DIRSUFFIX=`pwd | md5sum | cut -d " " -f 1`
LIB_HOME=./lib
MINIK_HOME=../lib
TMPDIR=`cygpath -m $TMP`/\-minik-cur5_local_$DIRSUFFIX
POI_HOME="${LIB_HOME}/poi"
HTMLPARSER_HOME="${LIB_HOME}/htmlparser"
SS_CSS2_HOME="${LIB_HOME}/ss_css2"
CRYPTO_HOME="${LIB_HOME}/crypto"

rm -rf $TMPDIR

if [ "$SRCTMP" == "iti" ] ; then
	ITI="-iti"
	SRCTMP=$2	
	POI_HOME=libj2se/poi
	CHART_HOME=libj2se/chart
	HTMLPARSER_HOME=libj2se/htmlparser
	SS_CSS2_HOME=libj2se/ss_css2
	CRYPTO_HOME=libj2se/crypto
fi
if [ "$ITI" != "" ] ; then
	ITI="-iti"
fi

if [ "$SRCTMP" == "" ] ; then
	#make this list automatic 
	SRCTMP="${LIB_HOME}/uij2se.jar ${LIB_HOME}/schema.jar ${LIB_HOME}/ocean.jar ${LIB_HOME}/genrap.jar ${LIB_HOME}/apij2se.jar"
fi

mkdir -p ${CRYPTO_HOME}
cp "${JAVA_HOME}"/jre/lib/jce.jar ${CRYPTO_HOME}/crypto.jar

ERRS="--errintfs genrap.geom.common.GeomErr genrap.logic.common.LogicErr genrap.odl.impl.common.ODLErr genrap.ui.appLogic.intf.converter.xls.XlsException genrap.manip.impl.err.ManipErrors"
MINIK="java -Xmx256M -cp ${MINIK_HOME}/minik.jar jminik.compiler.Compiler "
PARAM_SCHEMA_INTF="--immintf schema.runtime.datatypes.ImmObject"
PARAMS="${ITI} ${ERRS} -s ${SRCTMP} -m nianio ${SRCTMP} -c scripts/config -j --analyzedir genrap $PARAM_SCHEMA_INTF"
$MINIK $PARAMS
DONE="true"

rm -rf ${CRYPTO_HOME}
