#!/usr/bin/perl

use Imm;

sub findType {
	my ($id, %types) = @_;
	my $length = length $id;
	my $result = $types{$id};
	while (($result eq "") && ($length > 0)) {
		$length = $length - 1;
		$id = substr $id, 0, $length;
		$result = $types{$id};		
	}
	return ($result or die "no type for id");
}

my $typesFile = $ARGV[0] or die "USAGE: $0 file_with_types\n";
shift;

open IN, "<$typesFile" or die "No file $typesFile\n";
for my $line (<IN>) {
	%type = Imm::get($line);
	$types{Imm::value('iden', %type)} = Imm::value('type', %type);
}
close IN;

open $OUT, ">-";
while(my $line = <>) {
	%rec = Imm::get($line);
	$rec{'type'} = findType(Imm::value('iden', %rec), %types);
	Imm::print($OUT, %rec);
}
close $OUT;
